# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .rerank_response_results_item_document import RerankResponseResultsItemDocument

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class RerankResponseResultsItem(pydantic.BaseModel):
    document: typing.Optional[RerankResponseResultsItemDocument] = pydantic.Field(default=None)
    """
    The doc object which was ranked
    """

    index: int = pydantic.Field()
    """
    The index of the input document
    """

    relevance_score: float = pydantic.Field()
    """
    A relevance score assigned to the ranking
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
