# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class ToolParameterDefinitionsValue(pydantic.BaseModel):
    description: str = pydantic.Field()
    """
    The description of the parameter.
    """

    type: str = pydantic.Field()
    """
    The type of the parameter. Must be a valid Python type.
    """

    required: typing.Optional[bool] = pydantic.Field(default=None)
    """
    Denotes whether the parameter is always present (required) or not. Defaults to not required.
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
